PIC15C58	EQU 7FFh

;-------------------------------;
	ORG	0

	goto 	main

;-------------------------------;
;	REGISTERS
;-------------------------------;
	indir	equ	00	;
	tmr0	equ	01	;
	pc	equ	02	;
	status	equ	03	;
	fsr	equ	04	;
	serial	equ	05	;
	extern	equ	06	;
				;
	cmd	equ	07	; ॣ 
	addr	equ	08	;
	higbit	equ	09	;
	lowbit	equ	0A	;
	timeh	equ	0B	;
	timel	equ	0C	;
	count	equ	0D	;
	tmp_cmd	equ	0E	;
	tmp_adr equ	0F	;
				;
	adr_pg	equ	0B
;-------------------------------;
;	BITS
;-------------------------------;
	carry	equ	0	;
	zflags	equ	2	;
				;
	cs	equ	0	;
	clock	equ	1	;
	din	equ	2	;
	dout	equ	3	;
				;
	ready	equ	4	;
	read	equ	5	;
	write	equ	6	;
				;
	page0	equ     5	; select page bit 0
	page1	equ     6	; select pege bit 1
				;
;-------------------------------;
;	CONSTANTS
;-------------------------------;
	no_err	equ	00
	error	equ	01
	tries	equ	20

	c_read	equ	b'10000000'
	c_write	equ	b'01000000'
	c_erase	equ	b'11000000'
	c_eral	equ	b'00100000'
	c_wral	equ	b'00010000'
	c_ewen	equ	b'00110000'
	c_ewds	equ	b'00000000'

	adr_end	equ	7F
	vardly 	equ	01

	tim_val	equ	3A

;-------------------------------;
;	MACROS
;-------------------------------;
delay	MACRO			;
	nop			;
	nop			;
	nop			;
	nop			;
	nop			;
	nop			;
	nop			;
	nop			;
	nop			;
	nop			;
ENDM				; delay 2 us
				;
;///////////////////////////////;
;	MAIN			;
;-------------------------------;
main				;
;	movlw	b'11110000'
;	option			;  ॣ "option"

	clrf	serial		;
	movlw	b'11111000'	;  
	tris	serial		;
				;
	clrf	extern		;
	movlw	b'00000111'	;
	tris	extern		;
				;
	bsf	extern, read	; .   READ
	bsf	extern, write	; .   WRATE
				;
;-------------------------------; ??????????????????????????????????
	bsf	status, page0	; set page 1
	goto	rd_mw		; begin adress=0
rd_end				; 㧪   
				;
;-------------------------------;
wt_cs				;
	clrf	fsr
	bcf	serial, cs	;
	bcf	serial, clock	;
	bcf	serial, din	;
	bsf	extern, read	;
	bsf	extern, write	;
	bsf	extern, dout	;
	movlw	10
	movwf	addr
				;
w_cs	clrwdt
	btfss	extern, cs	;
	goto	w_cs		;  CS
				;
;-------------------------------;
rd_com				; ਥ ᮬ ᫨  CS
	clrf	cmd		;
	bcf	extern, read	;
				;
tst11	btfss	extern, clock	;
	goto	tst11		;
tst10	btfsc	extern, clock	;
	goto	tst10		; 1 takt command
				;
tst21	btfss	extern, clock	;
	goto	tst21		;
tst20	btfsc	extern, clock	;
	goto	tst20		; 2 takt command

tst31	btfss	extern, clock	;
	goto	tst31		;
tst30	btfsc	extern, clock	;
	goto	tst30		; 3 takt command ய襭
				;
tst41	btfss	extern, clock	;
	goto	tst41		;
tst40	btfsc	extern, clock	;
	goto	tst40		; 4 takt command
				;
tst51	btfss	extern, clock	;
	goto	tst51		;
tst50	btfsc	extern, clock	;
	goto	tst50		; 5 takt command

tst61	btfss	extern, clock	;
	goto	tst61		;
tst60	btfsc	extern, clock	;
	goto	tst60		;

tst71	btfss	extern, clock	;
	goto	tst71		;
tst70	btfsc	extern, clock	;
	goto	tst70		;

tst81	btfss	extern, clock	;
	goto	tst81		;
tst80	btfsc	extern, clock	;
	goto	tst80		;

tst91	btfss	extern, clock	;
	goto	tst91		;
tst90	btfsc	extern, clock	;
	goto	tst90		;

tst101	btfss	extern, clock	;
	goto	tst101		;
tst100	btfsc	extern, clock	;
	goto	tst100		;

tst111	btfss	extern, clock	;
	goto	tst111		;
tst110	btfsc	extern, clock	;
	goto	tst110		;

tst121	btfss	extern, clock	;
	goto	tst121		;
tst120	btfsc	extern, clock	;
	goto	tst120		;

tst131	btfss	extern, clock	;
	goto	tst131		;
tst130	btfsc	extern, clock	;
	goto	tst130		;

tst141	btfss	extern, clock	;
	goto	tst141		;
tst140	btfsc	extern, clock	;
	goto	tst140		;

	bcf	extern, dout
tst151	btfss	extern, clock	;
	goto	tst151		;
tst150	btfsc	extern, clock	;
	goto	tst150		;

tst161	btfss	extern, clock	;
	goto	tst161		;
tst160	btfsc	extern, clock	;
	goto	tst160		;

;-------------------------------;
out_d				;
	clrwdt
	movf	addr, 0		; ⥭   
	movwf 	fsr		;
out_d1	movf	indir, 0	;
	movwf	higbit		;
	incf	fsr		;

	movlw	8		;
	movwf	count		;
out_hi	rlf	higbit		;
tsdh1	btfss	extern, clock	;
	goto	tsdh1		;
	bcf	extern, dout	;
	btfsc	status, carry	;
	bsf	extern, dout	;
tsdh0	btfsc	extern, clock	;
	goto	tsdh0		; hige bite out
stp_hi	decfsz	count		;
	goto	out_hi		;
				;
	movf	indir, 0	;
	movwf	lowbit		;
	incf	fsr		;
	clrwdt			;
	movlw	8		;
	movwf	count		;
out_lo	rlf	lowbit		;
tsdl1	btfss	extern, clock	;
	goto	tsdl1		;
	bcf	extern, dout	;
	btfsc	status, carry	;
	bsf	extern, dout	;
tsdl0	btfsc	extern, clock	;
	goto	tsdl0		; low bite out
stp_lo	decfsz	count		;
	goto	out_lo		;
				;
end_td	bcf	fsr, 6		;
	bsf	fsr, 4		;
	goto	out_d1		;
				;
				;
;-------------------------------;
;-------------------------------;

	ORG	200

;-------------------------------;
;	READ MW			;
;-------------------------------;
rd_mw				;
	bcf	extern, read	;
	clrf	addr		; begin adress ROM
				;
	movlw	10
	movwf	adr_pg
rdp1	movlw	c_read		;
	movwf	cmd		;
	call	see		; read date
	delay
	movf	adr_pg, 0
	movwf	fsr		; pointer RAM
	movf	higbit, 0	;
	movwf	indir		;
	incf	fsr		;
	movf	lowbit, 0	;
	movwf	indir		;
	incf	fsr		;
	movf 	fsr, 0
	movwf	adr_pg
	incf	addr		;
	movlw	8		;
	xorwf	addr, 0   	;
	btfss	status, zflags	;
	goto	rdp1		;
				;
	movlw	30
	movwf	adr_pg
rdp2	movlw	c_read		;
	movwf	cmd		;
	call	see		; read date
	delay
	movf	adr_pg, 0		;
	movwf	fsr		; set page data 1
	movf	higbit, 0	;
	movwf	indir		;
	incf	fsr		;
	movf	lowbit, 0	;
	movwf	indir		;
	incf	fsr
	movf	fsr, 0
	movwf	adr_pg
	incf	addr		;
	movlw	10		;
	xorwf	addr, 0   	;
	btfss	status, zflags	;
	goto	rdp2		;
				;
	bsf	extern, read	;
	clrf	fsr		; set page data 0
	bcf	status, page0	; set page program 0
	goto	rd_end		;
				;
;-------------------------------;
;	SEE			;
;-------------------------------;
see				;
	movf	cmd, 0		;
	movwf	tmp_cmd		;
	movf	addr, 0		;
	movwf	tmp_adr		;
				;
	movlw	cmd		;
	movwf	fsr		;  ஢ ᫮  FSR
				;
	bsf	serial, cs	; ⠭ CS
	nop
	bsf	serial, din	;
	nop
	bsf	serial, clock	;
	delay			; --
	bcf	serial, clock	; start bit
	delay			; --
				;
	call	dout10		; adress and direct
				;
	movf	tmp_cmd, 0	;
	movwf	cmd		;
	movf	tmp_adr, 0	;
	movwf	addr		;    ஢ ᫮
				;
	btfsc	cmd, 6		; WRITE/ERASE
	goto	see2		;
	btfsc	cmd, 7		; READ
	goto	read_		;
	btfsc	cmd, 5		; EWEN/ERALL
	goto	see3		;
	btfsc	cmd, 4		; WRALL
	goto	write_		;
exit_	bcf	serial, cs	;
	retlw	no_err		; exit if EWDS
see2	btfss	cmd, 7		;
	goto	write_		;
exit2_	;call	rdychk          ; ERASE
	bcf	serial, cs	;
	;addwf	pc		;
	retlw	no_err		;
	;retlw	error		;
see3	btfsc	cmd, 4		;
	goto	exit_		; ERALL
	goto	exit2_		; EWEN
				;
read_	incf	fsr		; high bit
	call	din8		;
	incf	fsr		; low  bit
	call	din8		;
	goto	exit_		;
				;
write_	incf	fsr		; high bit
	call	dout8		;
	incf	fsr		; low  bit
	call	dout8		;
	goto	exit2_		;
				;
				;
;-------------------------------;
;	DOUT			;
; indir, serial, status, count	;
;-------------------------------;
dout10				;
	rlf	indir		;
	bcf	serial, din	; DIN=0
	btfsc	status, carry	;
	bsf	serial, din	;
	bsf	serial, clock	;
	delay			; --
	bcf	serial, clock	;
	delay			; --
				;
dout9				;
	rlf	indir		;
	bcf	serial, din	;
	btfsc	status, carry	;
	bsf	serial, din	;
	bsf	serial, clock	;
	delay			; --
	bcf	serial, clock	;
	delay			; --
				;
	rlf	indir		;
	btfsc	status, carry	;
	bsf	addr, 7		;
	rlf	indir		;
	btfsc	status, carry	;
	bsf	addr, 6		;
				;
	incf	fsr		;
dout8				;
	movlw	8		;
	movwf	count		;
d_o_8	bcf	serial, din	;
	rlf	indir		;
	btfsc 	status, carry	;
	bsf	serial, din	;
	bsf	serial, clock	;
	delay			; --
	bcf	serial, clock	;
	delay			; --
	decfsz	count		;
	goto 	d_o_8		;
	rlf	indir		;  ᫮ 
	bcf	serial, din	;
	retlw	no_err		;
				;
;-------------------------------;
;	DIN 8			;
; count, indir, serial,
;-------------------------------;
din8				;
	movlw	8		;
	movwf	count		; - ᮢ=8
				;
d_i_8	rlf	indir		; ᢮      ᮢ
	bcf	indir, 0	;   FSR  㫨 
				;
	delay			; --
	bsf	serial, clock	;
	delay			; --
	bcf	serial, clock	; takt CLK
				;
	btfsc	serial, dout	;
	bsf	indir, 0	; ᫨ = 1 ⠭
	decfsz	count		; count--
	goto	d_i_8		;
				;
	retlw	no_err		; return 0
				;
;-------------------------------;
;	TIME OUT		;
; timeh, timel
;-------------------------------;
time_out			;
	movlw	tim_val		;
	movwf	timeh		;
to2	clrf	timel		;
to1	decfsz	timel		;
	goto	to1		;
	decfsz	timeh		;
	goto	to2		;
	retlw	no_err		;
				;
;-------------------------------;

END


